/* 
C Source File
Created 9/7/00; 5:01:03 PM

 	Pas By: Greg (GForce)	
   email: gforceti86calc@email.com
 webpage: www.geocities.com/gdietsche

Pas for the TI-89 and TI-92+ provides a method of 
protecting basic programs from unauthorized access.

Copyright (C) 2000  Greg Dietsche

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#include "Pas.h"

////////////////////////////////////////////////////////////////////////////////
// _if ArgCount then set new password                                        //
// else wait for password and return retGood if a Good password is entered  //
// returns retBad if a bad password                                        //
// retError is included in the enum but is not used at this time          //
///////////////////////////////////////////////////////////////////////////
void _main()
{
	#ifdef EnableEncryption
		CryptDecrypt();	//decrypt the password
		Key=rand();		//change the magic number
	#endif
	
	if(ArgCount())
	{
		SetPassword();
		push_longint(retBad);
			
		#ifdef DebugMode
			dbgDisplayPassword();
		#endif
	
	#ifdef EnableEncryption
		CryptDecrypt();	//encrypt password
	#endif
		return;
	}

	if(EnterPassword())
		push_longint(retGood);
	else
		push_longint(retBad);

	#ifdef DebugMode
		dbgDisplayPassword();
	#endif
	
	#ifdef EnableEncryption
		CryptDecrypt();	//encrypt password
	#endif
	
	OSClearBreak();		//make SURE that the ON key wasn't pressed :)
}

////////////////////////////////////////////////////////////////////////////////
// SetPassword   asks for the old password via EnterPassword()               //
// asks for new password then confirms                                      //
//it is declared as inline as a hint to the compiler since the function is //
//only called once                                                        //
///////////////////////////////////////////////////////////////////////////
inline int SetPassword()
{
	int i;
	int sPassword[MaxPasswordLen];
		
	ST_busy(ST_IDLE);	//make it look nice
	
	for(i=0;i<MaxPasswordLen;i++)
		sPassword[i]=Password[i];
		
	ST_helpMsg("Pas v" CurVersion "-Enter Password");

		if(!EnterPassword())
		{
			ST_helpMsg("Bad Password");
			return FALSE;
		}
		
	ST_helpMsg("Type New Password");
		GetInput(&Password[0]);
		
	ST_helpMsg("Retype Password");
	
	if(!EnterPassword())
	{
		for(i=0;i<MaxPasswordLen;i++)
		Password[i]=sPassword[i];

		ST_helpMsg("Password NOT Set");
		return FALSE;
	}

	ST_helpMsg("Password Set");
	return TRUE;
}

////////////////////////////////////////////////////////////////////////////////
//Asks for the current password (no user interface)                          //
//returns FALSE if a bad password was typed                                 //
//returns TRUE if a good password was typed                                //
////////////////////////////////////////////////////////////////////////////
int EnterPassword()
{
	int arBuf[MaxPasswordLen];
	int i;
	int ii=GetInput(&arBuf[0]);

	for(i=0;i<ii;i++)
	{
		if(Password[i]!=arBuf[i])
			return FALSE;

	}
	return TRUE;
}

///////////////////////////////////////////////////////////////////////////////
//Reads keypresses and returns them through the array pointed to by pBuf    //
//returns the number of key presses                                        //
////////////////////////////////////////////////////////////////////////////
int GetInput(int *pBuf)
{
	int i=1;		//initialize counter to 1 so we don't pass the end of the array

	OSFreeTimer(USER_TIMER);
	OSRegisterTimer(USER_TIMER,20);

	while(!OSTimerExpired(USER_TIMER))
	{
		if(i>MaxPasswordLen)
			break;
		
		if(kbhit())
		{
			i++;		//increment the counter
			*pBuf++=ngetchx();
			OSTimerRestart(USER_TIMER);	
		}
	}
	//last element is zero
	*pBuf=0;	
	return i;
}

#ifdef EnableEncryption
//////////////////////////////////////////////////////////////////////////////
//encrypts and decrypts the password                                       //
////////////////////////////////////////////////////////////////////////////
void CryptDecrypt()
{
	int I;
	for(I=0;I<MaxPasswordLen;I++)
	Password[I]^=Key;
}
#endif

#ifdef DebugMode
////////////////////////////////////////////////////////////////////////////////
//This routine is used for debugging                                         //
//it displays the current password (the int values)                         //
//and the current key                                                      //
////////////////////////////////////////////////////////////////////////////
void dbgDisplayPassword()
{
	int i;
	clrscr();
	for(i=0;i<MaxPasswordLen;i++)
	printf("%i\n",Password[i]);
	ngetchx();
}
#endif
