/* 
C Header File
Created 10/12/00; 4:45:51 PM

 	Pas By: Greg (GForce)	
   email: gforceti86calc@email.com
 webpage: www.geocities.com/gdietsche

Compiled with TIGCC .8 and the TICGCC library version 2.22
GCC Switches were:       -Os -Wall -W
Assembler Switches were: -k -g -t
Linker Switches were:

Pas for the TI-89 and TI-92+ provides a method of 
protecting basic programs from unauthorized access.

Copyright (C) 2000  Greg Dietsche

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/*the password encryption could use a little help
 it could be easily beaten if one uses a hex editor
 to solve the problem i recommend recompiling this source code but in
 place of the var called Key substitute your own number
 something like
 #define Key 3
 so you can change it easily
 Key should be between 1 and 65535 for best results...
 and then remove references to the old system of storing the key in the 
 executable
 Using this method it becomes quite hard to crack the password because
 there are 65535 different numbers to check... and that number is not easily
 found in the executable */
 
			/*my definitions for CuSToM compilation*/
//#define DebugMode					//this is used to indicate debug mode...
//#define EnableEncryption	//encrypts the password
#define MaxPasswordLen 10		//used to control the maximum password length
#define CurVersion "3.0"		//the current version string

///////////////////////////////////////////////////////////////////////////////
//error checking for Max Password Length
#if MaxPasswordLen<1 || MaxPasswordLen>20
	#error: It is recommended that MaxPasswordLen be between 1 and 20
#endif

//test to see if we're debugging
#ifdef DebugMode
	#define SAVE_SCREEN
	#warning Program Complied in Debug Mode
#endif
/////////////////////////////////////////////////////////////////////////////

//TIGCC stuff...
#define OPTIMIZE_ROM_CALLS
#define RETURN_VALUE pass
#include <tigcclib.h>

//what platforms should code be produced for
int _ti89;           			// Produce .89Z File
int _ti92plus;						// Produce .9XZ File

//function prototypes
void _main();								//think GOD
inline int SetPassword(); 	//Sets the new password
int EnterPassword(); 				//The main get password loop
int GetInput(int *pBuf);		//Waits for keyboard input
void CryptDecrypt();				//encrypts or decrypts the password array
void dbgDisplayPassword();	//Debugging Routine

//Global Stuff
enum RetFLAGS {retBad,retGood,retError};

//The password array is null terminated
//so MaxPasswordLen+1 number of elements need to be initialized

#ifdef EnableEncryption
//the first element should be 0 xor key in the Password array
	static int Password[MaxPasswordLen+1]={};
//this could be moved someplace else to make it harder to crack...
	static int Key=0;
	#warning: Encryption is enabled program size will be affected
#else
	static int Password[MaxPasswordLen+1]={};	
	#warning: Encryption is NOT enabled
#endif
